/* --------------------------------------------------------------------
DISTRIBUTED SYSTEMS                                      1 October 2022

This model is provided for completeness, but does not have much use so
far

NetworkName and NetworkState are redefined in net.als, so this file is
not strictly compatible with net.als.
-------------------------------------------------------------------- */

sig DistributedSystemName { }
   sig NetworkName extends DistributedSystemName { }

sig Machine { }                    -- a computer or computerized device

sig Module { }                  -- a functional unit of hardware and/or
                               -- software logic installed on a machine

sig LegalPerson { }      -- a person or legally-recognized organization

sig NetworkState { }

sig DistributedSystem {
   systemName: DistributedSystemName,
   scope: some Machine,
   modules: scope -> some Module     -- a machine in scope must have at
}                                    -- least one module of the system,
                                     -- and may have more than one

sig Network extends DistributedSystem {
   administrativeAuthority: LegalPerson,
   state: NetworkState                 }
{  systemName in NetworkName           }

pred IsNetwork [n: Network]  { 
   # n.scope = 2
   # (n.scope).(n.modules) = 3  }
run IsNetwork for 1 but 2 Machine, 3 Module
